=== modified file 'apply_changeset.py'
--- apply_changeset.py	2005-07-04 06:51:52 +0000
+++ apply_changeset.py	2005-07-10 15:14:15 +0000
@@ -81,11 +81,14 @@
         shutil.rmtree(tempdir)
 
 
-def apply_changeset(branch, from_file, auto_commit=False):
+def apply_changeset(branch, from_file, reverse=False, auto_commit=False):
     import sys, read_changeset
 
+    if reverse:
+        raise Exception('reverse not implemented yet')
+        
     cset_info, cset_tree, cset_inv = \
-            read_changeset.read_changeset(from_file)
+            read_changeset.read_changeset(from_file, branch)
 
     _install_info(branch, cset_info, cset_tree, cset_inv)
 

=== modified file 'read_changeset.py'
--- read_changeset.py	2005-07-04 06:51:52 +0000
+++ read_changeset.py	2005-07-10 15:14:15 +0000
@@ -325,7 +325,7 @@
             kind = tree.get_kind(file_id)
             ie = InventoryEntry(file_id, name, kind, parent_id, text_id=text_id)
             ie.text_size, ie.text_sha1 = tree.get_size_and_sha1(file_id)
-            if ie.text_size is None:
+            if (ie.text_size is None) and (kind != 'directory'):
                 raise BzrError('Got a text_size of None for file_id %r' % file_id)
             inv.add(ie)
         return inv
@@ -383,6 +383,9 @@
         found = False
         for line in self._next():
             if found:
+                # not all mailers will keep trailing whitespace
+                if line == '#\n':
+                    line = '# \n'
                 if (line[:2] != '# ' or line[-1:] != '\n'
                         or line[2:-1] != header[0]):
                     raise MalformedHeader('Found a header, but it'
@@ -852,6 +855,8 @@
             # If the entry does not have a patch, then the
             # contents must be the same as in the base_tree
             ie = self.base_tree.inventory[file_id]
+            if ie.text_size is None:
+                return ie.text_size, ie.text_sha1
             return int(ie.text_size), ie.text_sha1
         content = self.get_file(file_id).read()
         return len(content), sha_string(content)
@@ -861,10 +866,10 @@
     def __iter__(self):
         for file_id in self._new_id_r.iterkeys():
             yield file_id
-        for file_id in self.base_tree:
-            if self.id2path(file_id) is None:
+        for path, entry in self.base_tree.inventory.iter_entries():
+            if self.id2path(entry.file_id) is None:
                 continue
-            yield file_id
+            yield entry.file_id
 
 
 def patched_file(file_patch, original):

